package org.codehaus.xfire.java.message;

import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.XMLStreamWriter;

import org.codehaus.xfire.MessageContext;
import org.codehaus.xfire.java.JavaService;

/**
 * Create a MessageReaders and MessageWriters for a JavaService.
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Apr 7, 2004
 */
public class MessageBridgeFactory
{

	public static MessageBridge createMessageBridge( JavaService service,
                                                     MessageContext context,
                                                     XMLStreamReader request,
                                                     XMLStreamWriter response )
	{
        AbstractMessageBridge bridge;
        
		if ( service.getStyle().equals("wrapped")
             &&
             service.getUse().equals("literal") )
        {
            bridge = new WrappedBridge( service, context, request, response );
        }
        else if ( service.getStyle().equals("document")
                  &&
                  service.getUse().equals("literal") )
        {
            bridge = new DocumentBridge( service, context, request, response );
        }
        else
        {
        	throw new UnsupportedOperationException( "Service style/use not supported." );
        }
        
        return bridge;
	}
}
