package org.codehaus.xfire.java.wsdl;

import java.util.Set;

import javax.wsdl.WSDLException;

import org.codehaus.xfire.AbstractXFireComponent;
import org.codehaus.xfire.java.JavaService;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.transport.TransportManager;
import org.codehaus.xfire.wsdl.WSDL;
import org.codehaus.xfire.wsdl.WSDLBuilder;

/**
 * Create a WSDL document for a JavaService.
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Apr 7, 2004
 */
public class JavaWSDLBuilder
	extends AbstractXFireComponent
	implements WSDLBuilder
{
    private TransportManager manager;
    
    public JavaWSDLBuilder( TransportManager manager )
    {
        this.manager = manager;
    }

	/**
	 * @param service
	 * @return
	 */
	public WSDL createWSDL( Service s )
        throws WSDLException
	{
        JavaService service = (JavaService) s;
        
        Set transports = manager.getTransports( service.getName() );
	    
		if ( service.getStyle().equals("wrapped")
             &&
             service.getUse().equals("literal") )
        {
            return new WrappedWSDL( service, transports );
        }
        else if ( service.getStyle().equals("document")
                  &&
                  service.getUse().equals("literal") )
        {
            return new DocumentWSDL( service, transports );
        }
        else
        {
        	throw new UnsupportedOperationException( "Service style/use not supported." );
        }
	}
}
