package org.codehaus.xfire.java.mapping;

import javax.xml.namespace.QName;

import junit.framework.TestCase;

import org.codehaus.xfire.java.mapping.CustomTypeMapping;
import org.codehaus.xfire.java.type.StringType;


/**
 * CustomTypeMappingTest
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 */
public class CustomTypeMappingTest
    extends TestCase
{
    public void testTM() throws Exception
    {
        CustomTypeMapping mapping = new CustomTypeMapping();
        
        QName qname = new QName( "urn:soap", "String" );
        
        mapping.register( String.class, qname, StringType.class );
        
        assertTrue( mapping.isRegistered( String.class, qname ) );
        
        assertNotNull( mapping.getType( String.class, qname ) );
        
        
        CustomTypeMapping child = new CustomTypeMapping( mapping );
        
        assertTrue( child.isRegistered( String.class, qname ) );
        
        assertNotNull( child.getType( String.class, qname ) );
    }
}
