package org.codehaus.xfire.java.types;

import org.codehaus.xfire.SOAPConstants;
import org.codehaus.xfire.fault.SOAP11FaultHandler;
import org.codehaus.xfire.handler.SoapHandler;
import org.codehaus.xfire.java.AbstractJavaTest;
import org.codehaus.xfire.java.DefaultJavaService;
import org.codehaus.xfire.java.JavaServiceHandler;
import org.codehaus.xfire.java.test.PrimitiveService;
import org.codehaus.xfire.java.wsdl.JavaWSDLBuilder;
import org.dom4j.Document;


/**
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Feb 21, 2004
 */
public class PrimitiveTest
    extends AbstractJavaTest
{
    public void setUp() throws Exception
    {
        super.setUp();
        
        DefaultJavaService service = new DefaultJavaService();
        service.setName("PrimitiveService");
        service.setDefaultNamespace("urn:PrimitiveService");
        service.setServiceClass(PrimitiveService.class.getName());
        service.setSoapVersion(SOAPConstants.SOAP11_ENVELOPE_NS);
        service.setStyle(SOAPConstants.STYLE_WRAPPED);
        service.setUse(SOAPConstants.USE_LITERAL);
        service.setFaultHandler(new SOAP11FaultHandler());
        service.setWSDLBuilder(new JavaWSDLBuilder( getXFire().getTransportManager() ));
        service.setAutoTyped(true);
        
        SoapHandler handler = new SoapHandler(new JavaServiceHandler());
        service.setServiceHandler( handler );
        
        service.setTypeMappingRegistry(getRegistry());
        
        service.initialize();
        
        getServiceRegistry().register(service);
    }
    
    public void testWrappedPrimitive() throws Exception
    {
        Document response = 
            invokeService("PrimitiveService", "/org/codehaus/xfire/java/types/echoInteger.xml");

        addNamespace("p", "urn:PrimitiveService");
        assertValid("//p:out[text()='1']", response);

        Document doc = getWSDLDocument( "PrimitiveService" );
    }
    
    public void testPrimitive() throws Exception
    {
        Document response = 
            invokeService("PrimitiveService", "/org/codehaus/xfire/java/types/echoInt.xml");

        addNamespace("p", "urn:PrimitiveService");
        assertValid("//p:out[text()='1']", response);
        
        Document doc = getWSDLDocument( "PrimitiveService" );
    }
}
